#!/bin/bash
#internet_permit设置为0,则无法访问外网，如果设置为1,则可以访问外网。访问外网则会导致cipso发送失效，设置为1仅仅是调试的用途，默认设置为0.
#可以在系统启动后，临时手工执行 echo "0.0.0.0/0 @" > /sys/fs/smackfs/netlabel 的方式访问internet。
#本版本默认不开启访问外网功能，暂时无法修改internet_permit的值
internet_permit=0

hostsmconf="/etc/label/hostSM"
initlabelconf="/etc/label/initmb"
netcardsmconf="/etc/label/netcardSM"
usersmconf="/etc/label/userSM"

mkdir -p /var/log/tmpa

if [ "X`id -u`" != "X0" ]; then
    echo "This script need root to execute."
    exit
fi
if [ ! -f /sys/fs/smackfs/netlabel ]; then
    echo "启动菜单中未启用 security=smack ，请检查！"
    exit    
fi
if [ "X$internet_permit" != "X0" ]; then
   if [ -f /sys/fs/smackfs/netlabel ]; then
      echo "0.0.0.0/0 @" > /sys/fs/smackfs/netlabel
   fi
fi

#echo "================================================"
#echo "=主机Label设置初始化"
#if [ -f $hostsmconf ]; then
#	host_secmark=`cat $hostsmconf | head -n1`
#        echo "Host Label is:$host_secmark"
#	if [ "X$host_secmark" != "X" ]; then
#	   setfattr -n security.secmarkhost -v $host_secmark /lib/x86_64-linux-gnu/ld-2.24.so
#	   if [ $? -eq 0 ]; then
#	      echo "Set host label successfully."
#           else
#	      echo "Set host label failed."
#	   fi
#   	else
#	   echo "Host label 为空"
#   	fi
#    echo "=主机Label   Done."
#else
#    echo "=主机Label配置文件 $hostsmconf  不存在， 跳过."
#fi

#完整性检查
function labelverify(){
  return 2
  labelstr=$1
  if [ "X$labelstr" = "X" ]; then
	#$1 is label string
	echo "The Label string $user_label is Null!" >> /var/log/tmpa/doi_log.txt
     	return 1
  else
        labellen=`echo ${labelstr} | wc -m`
	if [ $labellen -lt 20 ]; then
	   echo "The len of Label string $user_label is wrong!" >> /var/log/tmpa/doi_log.txt
     	   return 1
        fi
  fi
 # labellenstr=$((16#${labelstr:2:4}))
 # labellen1=`expr $labellenstr + 1`
 # labellen2=`echo $labelstr | wc -c`
  if [ "X$labellen1" = "X$labellen2" ]; then
	return 2
  fi
  echo "The Label string $user_label is wrong!" >> /var/log/tmpa/doi_log.txt
  return 1
}


echo "================================================"
echo "===============================================`date`" > /var/log/tmpa/doi_log.txt
echo "=网卡Label设置初始化"
if [ -f $netcardsmconf ]; then
    while read netcard_label
    do
    	net_secmark=${netcard_label#*:}
        labelverify $net_secmark
        if [ $? -eq 1 ]; then
           exit
        fi

	devname=${netcard_label%:*}

	    if [ -f "/sys/class/net/$devname/secmark" ];then
	        echo "echo $net_secmark > /sys/class/net/$devname/secmark"
	        echo "echo $net_secmark > /sys/class/net/$devname/secmark" >> /var/log/tmpa/doi_log.txt
	        echo $net_secmark > /sys/class/net/$devname/secmark	
	    else
		#netif=`ifconfig -s | grep -v Iface | grep -v ^lo | head -n1 | awk '{print $1}'`
		netifpath=`find /sys/class/net/ | grep -v lo | grep -v /$`
		netif=`basename $netifpath`
		echo $netif
	        if [ -f /sys/class/net/${netif}/secmark ]; then
	           echo "$net_secmark > /sys/class/net/${netif}/secmark" 
	           echo "$net_secmark > /sys/class/net/${netif}/secmark" >> /var/log/tmpa/doi_log.txt 
	           echo $net_secmark > /sys/class/net/${netif}/secmark
		   sed -i 's/eno1/'${netif}'/' /etc/label/netcardSM
		fi	
	    fi
	
    done < $netcardsmconf

    echo "=网卡Label   Done."
else
    echo "=网卡Label配置文件 $hostsmconf  不存在， 跳过."
fi

echo "================================================"
echo "=用户Label设置初始化"
if [ -f $usersmconf ]; then
    while read user_label
    do
        zero="00000000"
	o="00"
	pre_secmark=${user_label#*:}

	labelverify $pre_secmark
	if [ $? -eq 1 ]; then
	   break 
	fi
        

#	hostSM=`cat $hostsmconf`
#	secmark_mj=${pre_secmark:0:2}
#	host_mj=${hostSM:0:2}
#	echo "host mj=$host_mj user mj=$secmark_mj"
#	if [ $((16#$secmark_mj)) -lt $((16#$host_mj)) ];then
#		mj=$secmark_mj
#	else
#		mj=$host_mj
#	fi
#	postlabel_before=${pre_secmark:0:11}
#	postlabel_last=${pre_secmark:12:24}
	postlabel=$pre_secmark
	echo "user_exec_label=$postlabel"
#	pre_doi=${pre_secmark:12:8}
#	doi_num=$pre_doi
#	echo $doi_num
#	user_doi=$((16#$doi_num))
#	echo $user_doi

	uid=${user_label%:*}
	prename=`getent passwd $uid`
	if [ "X$prename" = "X" ]; then
	  continue 
	fi
	user_name=${prename%%:*}
	user_home=`echo ${prename} | awk -F: '{print $6}'`
	user_secmark="$uid $user_name $postlabel"

	echo "setfattr -n security.SMACK64 -v $postlabel $user_home" >> /var/log/tmpa/doi_log.txt
	if [ "X${user_home}" != "X" ]; then
	    echo $user_home >> /tmp/log.txt
	    if [ -d $user_home ]; then
	        #echo "setfattr -n security.secmark -v $pre_secmark $user_home"
	        setfattr -n security.SMACK64 -v $postlabel $user_home
		if [ $? -eq 0 ]; then
			echo "Set user home label ok" >> /var/log/tmpa/doi_log.txt
		else
			echo "Set user home label fail" >> /var/log/tmpa/doi_log.txt
		fi
	    fi
	fi

	version=${pre_secmark:0:2}
	semanteme=${presecmark:2:8}		
	pre_cat=${pre_secmark:10:8}
	selfdef=${pre_secmark:18:2}
	echo ==============
	echo "版本密级 1Byte：$version"
	echo "类别 4Byte：$pre_cat"
	echo "语义标识符 4Byte：$semanteme"
	echo "自定义 1Byte：$selfdef"
	echo ==============
	user_domain="${version}${semanteme}${pre_cat}${selfdef}"
	echo $user_domain
	echo $user_secmark
	    
#	if [ "X$user_doi" != "X$zero" ];then
#	    echo "netlabelctl cipso add pass doi:$user_doi tags:7" >> /var/log/tmpa/doi_log.txt
#           netlabelctl cipso add pass doi:$user_doi tags:7 
#
#	        echo "netlabelctl map add domain:$user_domain  protocol:cipso,$user_doi" >> /var/log/tmpa/doi_log.txt
#	        netlabelctl map add domain:$user_domain  protocol:cipso,$user_doi
#	fi
	if [ -f "/sys/fs/smackfs/users" ];then
	    echo "$user_secmark >>  /sys/fs/smackfs/users" >> /var/log/tmpa/doi_log.txt	
	    echo "$user_secmark" >>  /sys/fs/smackfs/users	
	    #break
        else
	        sleep 1
	    fi
	
    done < $usersmconf
else
    echo "=用户Label配置文件 $hostsmconf  不存在， 跳过."
fi



echo "================================================"
echo "=主机Label DOI等设置初始化"
if [ -f $initlabelconf ]; then
    while read user_label
    do
        labelverify $user_label
        if [ $? -eq 1 ]; then
           break
        fi

	zero="00000000"
	o="00"
	pre_secmark=${user_label}
	
	version=${pre_secmark:0:2}
	semanteme=${pre_secmark:2:8}
	pre_cat=${pre_secmark:10:8}
	selfdef=${pre_secmark:18:2}
	echo ==============
	echo "版本密级 1Byte：$version"
	echo "语义标识符 4Byte：$semanteme"
	echo "类别 4Byte：$pre_cat"
	echo "自定义 1Byte：$selfdef"
	echo ==============
	user_domain="${version}${semanteme}${pre_cat}${distr}"
	echo $user_domain
	echo $user_secmark
	
    done < $initlabelconf
else
    echo "=主机Label配置文件 $initlabelconf  不存在， 跳过."
fi

if [ -f $hostsmconf ]; then
    while read host_label
    do
         logger -i -s -p kern.info "devstatelog        ?        root        $hostsmconf        0.0.0.0        up        success "
    done < $hostsmconf
fi
###########
#以上代码需要每次启动执行，以下代码执行一次即可。
if [ ! -f /etc/default/file_m_first ]; then
   /usr/sbin/setdefaultlabel
   /usr/sbin/set_file_secmark /etc/label/file_m
fi
/usr/sbin/applabel.sh &

#while true
for dm in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 
    do
    res=`ps -e | grep lightdm`
    if [ "X$res" != "X" ];then
        sync
        echo 3 > /proc/sys/vm/drop_caches
        echo "gdm found dm"
        break
    else
        echo "Not found dm"
        sleep 3
    fi
done

###########
#Kernel 3.13.6 225
#if labeldebug, $? = 0, then do nothing. else, write a label
#grep -q labeldebug /proc/cmdline
#if [ $? -ne 0 ]; then
#   echo "84002401014831302f2e3b3a393845501012" > /sys/fs/smackfs/onlycap
#fi
###########


